#include<ESP8266WiFi.h>
#include<WiFiClient.h>
#include<ESP8266WebServer.h>
#include <Wire.h>   
#include <Servo.h>
#define BLYNK_PRINT Serial
#include <BlynkSimpleEsp8266.h>        
#include "SH1106.h"
#include "HX711.h"
#define DOUT  D5
#define CLK  D6
HX711 scale(DOUT, CLK);
int time1=0;
float weight=0.0; 
float calibration_factor = 419640; 
 
//dripsensor
int a = 0;
int count=0;
int laserpin = D4;
int drip=0;

//oled
#define OLED_RESET -1

SH1106 display(0x3c, D2, D1);  

//servo
Servo servo_1; // Giving name to servo.

//website-wifi
String page = "";
const char* ssid="fab-stpi-2.4";
const char* password = "coolship738";

ESP8266WebServer server(80);
// Variable to store the HTTP request
int ml=0;
int count2=0;
int l_value=0;
int c_value=0;
int c_state=0;
int l_state=0;

//char auth[ ] = "BdX-PVzIew-D3wCstVJGQUchd8T5iyty";

// Your WiFi credentials.
// Set password to "" for open networks.

char ssid1[ ] = "fab-stpi-2.4";
char pass1[ ] = "coolship738";

void setup()
{
ESP.wdtEnable(65535);
//Blynk.begin(auth, ssid1, pass1);
pinMode (laserpin,OUTPUT);
pinMode(A0,INPUT);
Serial.begin(115200);
digitalWrite(laserpin,HIGH);
 //scale.set_scale();
 //scale.tare();

//BUZZER & LED
pinMode (D7,OUTPUT);
pinMode (D8,OUTPUT);
digitalWrite (D7,LOW);
digitalWrite (D8,LOW);

//Servo

servo_1.attach(D3); // Attaching Servo to D3
servo_1.write (120); // Servo will move to 45 degree angle.

//OLED
display.init();
display.flipScreenVertically();


//WIFI
  Serial.println("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) 
  {
    delay(500);
    Serial.print(".");
    display.println("WiFi connecting...          ");
    
  }
  
  
  Serial.println("");
  Serial.println("WiFi connected..!");
  Serial.print("Got IP: ");  
  Serial.println(WiFi.localIP());
  
  
  server.on("/", []()
  {
    page = "<html><head><title>IOT based IV Dripmonitoring </title>";
    page += "</head><style type=\"text/css\">table {border-collapse: collapse;";
    page += "}table, th, td {border: 1px solid black;font-size: larger;";
    page += "text-align:center;}</style><body><center><h1>FABLAB,STPI-Bhubaneswar";
    page += "Design</h1><h3>IOT BASED IV Drip MONITORING</h3><br>";
    //page += "<h5>Name Of Patient:-</h5><br>";
    //page += "<h5>Hospital bed no:-101</h5><br>";
    page += "</h1><h3>DRIP FACTOR = 20</h3><br>";
    page += "<table style=\"width: 600px;height: 250px;\"><tr><th>IV DRIP</th";
    page += "><th> DRIP COUNT</th></tr><tr><td>TOTAL</td><td>" + String(drip) + "</td></tr><tr>";
    page += "<table style=\"width: 600px;height: 250px;\"><tr><th>  volume</th";
    page += "><th>IV Amount</th></tr><tr><td>ml</td><td>" + String(ml) + "</td></tr><tr>";
    page += "<meta http-equiv=\"refresh\" content=\"5\">";
    server.send(200, "text/html", page);
  });

   server.begin();
   Serial.println("HTTP server started");
   weight_sense();
   ml=weight*1000;
   Serial.print(ml);
}


void loop() 
{

  int x ;
  x=analogRead(A0);
   if (x>=75 && a==0)
   {
    a=1;
   }
   else if (x<75 && a==1)
        {
          a=0;
          drip++;
        }

count2=drip/20;
c_state=count2;
if(l_state!=c_state)
{
ml=ml-count2;
}
l_state=c_state;
count2=0;

Serial.println(x);
display.setFont(ArialMT_Plain_10);
display.setTextAlignment(TEXT_ALIGN_LEFT);
display.drawString(0,10, "IOT BASED DRIPMONITOR");
display.drawString(0,20, "Dripfactor = 20");
display.drawString(0,30, "Dripcount:"+String(drip));
display.drawString(0,40, "MilliLitre:"+String(ml));
display.display();
//Blynk.virtualWrite(V1,drip);
//Blynk.virtualWrite(V2,ml);

  if (ml<=50)

 {
 servo_1.write (80); // Servo will move to 45 degree angle.
 digitalWrite (D7,HIGH);
 digitalWrite (D8,HIGH);
  }
 server.handleClient();
 delay(1);
 display.clear();
 //Blynk.run();
}

float weight_sense()
{
  scale.set_scale(calibration_factor);
  weight = scale.get_units();
  weight=abs(weight); 
  return weight; 
}
